#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "types.h"
#include "fonctions_coeur.h"


void creation(short** grille, short niveau, short taille){
	short** grille2;
	place p;
	short numero, nb_pass, nb_supp, i, j;
	bool next;
	short nbchiffres;

	srand(time(0));

	grille2 = malloc(taille * sizeof(short *));
  if (grille2 == NULL)
    exit(EXIT_FAILURE);

	for (i=0;i<taille;i++){
    grille2[i] = malloc(taille * sizeof(short));
		if (grille2[i] == NULL){
      for (j=0;j<i;j++){
        free(grille2[j]);
      }
			exit(EXIT_FAILURE);
    }
	}

	/* On genere une grille complete */
	generation(grille, taille);

	if(niveau==1)
		nbchiffres=50;
	else if(niveau==2)
		nbchiffres=32;
	else
		nbchiffres=0;

	nb_pass=0;
	nb_supp=0;
	next=false;

	do{
		if(!next){
			/* On choisi une case au hasard */
			p.x = rand()%taille;
			p.y = rand()%taille;
		}
		else{
			/* On avance d'une case */
			case_suivante(&p, taille);
		}

		/* Si la case ne contient pas 0
		On conserve le chiffre contenu dans la case,
		On met la sase  0
		Et on copie la grille dans grille2 */
		if(grille[p.y][p.x]!=0){
			numero=grille[p.y][p.x];
			grille[p.y][p.x]=0;
			copie(grille, grille2, taille);

			/* Si la grille n'est pas resolvable
			On incremente une variable pour savoir si d'autres chiffres peuvent etre retirs de la grille
			On remet le numero dans la case
			On va passer  la case suivante*/
			if(!resolution(grille2, taille)){
				nb_pass++;
				grille[p.y][p.x]=numero;
				next=true;
			}
			else{
				/* On remet le compteur  zero ds qu'on retire une case
				On va choisir une autre case au hasard  */
				nb_pass=0;
				next=false;
				nb_supp++;
			}
		}
		else{
			/* On incremente une variable pour savoir si d'autres chiffres peuvent etre retirs de la grille
			On va avancer d'une case si celle-ci contient 0 */
			nb_pass++;
			next=true;
		}
	}
	while(nb_pass<=(taille*taille) && nb_supp<((taille*taille)-nbchiffres));
	/* Si on a avanc plus de 81 fois c'est qu'on ne peut plus retirer d'autres chiffres de la grille */
}
