#include <stdlib.h>
#include <stdio.h>

#include "types.h"
#include "fonctions_coeur.h"

int main(int argc, char *argv[])
{
	short taille=9;
	short i,j;

	short** grille_complete = NULL;
	short** grille_depart = NULL;

	short niveau=0;

	/* creation des tableau dynamiques */
	grille_complete = malloc(taille * sizeof(short *));
	if (grille_complete == NULL)
    exit(EXIT_FAILURE);

	grille_depart = malloc(taille * sizeof(short *));
	if (grille_depart == NULL)
    exit(EXIT_FAILURE);

	for (i=0;i<taille;i++){
    grille_complete[i] = malloc(taille * sizeof(short));
		if (grille_complete[i] == NULL){
      for (j=0;j<i;j++){
        free(grille_complete[j]);
      }
			exit(EXIT_FAILURE);
    }

    grille_depart[i] = malloc(taille * sizeof(short));
		if (grille_depart[i] == NULL){
      for (j=0;j<i;j++){
        free(grille_depart[j]);
      }
			exit(EXIT_FAILURE);
    }
  }


	/* creation d'une grille de dpart, d'une grille en cours et d'une grille complte*/
	creation(grille_depart, niveau, taille);
	copie(grille_depart, grille_complete, taille);
	resolution(grille_complete, taille);

	/* Afficher les grilles */
	printf(" sudoku\n");
	printf("\n");
	for(i=0;i<taille;i++){
		for(j=0;j<taille;j++){
			if(grille_depart[i][j]==0)
				printf(" -");
			else
				printf(" %i", grille_depart[i][j]);
		}
		printf("\n");
	}
	printf("\n");

    getchar();

	for(i=0;i<taille;i++){
		for(j=0;j<taille;j++){
			printf(" %i", grille_complete[i][j]);
		}
		printf("\n");
	}
	getchar();



	/* Liberation des pointeurs */
	for (i=0;i<taille;i++){
    free(grille_complete[i]);
		free(grille_depart[i]);
	}
	free(grille_complete);
	free(grille_depart);

  return EXIT_SUCCESS;
}
