#ifndef DEF_FCTS
#define DEF_FCTS

	/* Creer une grille  trous */
	void creation(short** grille, short niveau, short taille);
	/* Genere un sudoku */
	void generation(short** grille, short taille);
	/* Resoud le sudoku */
	bool resolution(short** grille, short taille);
	/* Valide un sudoku*/
	bool valider(short** grille, short taille);

	/* Passe  la case suivante dans une grille carree de largeur dim */
	void case_suivante(place* p, short dim);

	/* Rempli une grille de 0 */
	void remplir_zero(short** grille, short taille);
	/* Copie une grille dans une autre */
	void copie(short** grille, short** grille2, short taille);
	/* Verifie si la grille est resolue ou non */
	bool rempli(short** grille, short taille);

	/* Calcule le nombre de fois ou un chiffre apparait dans les listes de chiffres possibles d'une colonne */
	short colonne_nbfois(short chiffre, place p, liste** l, short taille);
	/* Calcule le nombre de fois ou un chiffre apparait dans les listes de chiffres possibles d'une ligne */
	short ligne_nbfois(short chiffre, place p, liste** l, short taille);
	/* Calcule le nombre de fois ou un chiffre apparait dans les listes de chiffres possibles d'une region */
	short region_nbfois(short chiffre, place p, liste** l, short taille);

	/* Supprime la possibilit d'avoir le chiffre dans la colonne */
	void colonne_supp(short chiffre, place p, liste** l, short taille);
	/* Supprime la possibilit d'avoir le chiffre dans la ligne */
	void ligne_supp(short chiffre, place p, liste** l, short taille);
	/* Supprime la possibilit d'avoir le chiffre dans la region */
	void region_supp(short chiffre, place p, liste** l, short taille);

	/* Vrifie si le chiffre se trouve dans la ligne ou dans la colonne */
	bool verif_lc(short** grille, place p, short chiffre);

	/* Cr un tableau de listes de chiffres de 1  9 */
	void initialiser(liste** l, short taille);

	/* Supprime un chiffre de la liste */
	liste supp_liste(liste l, short chiffre);
	/* Supprime tous les chiffres de la liste sauf le bon */
	liste supp_tous_sauf(short chiffre, liste l);
	/* Supprime l'element en tete de liste */
	liste supp_tete(liste l);
	/* Ajoute un entier en tete de liste */
	liste ajout_tete(liste l, short e);
	/* Teste si un chiffre se trouve dans une liste */
	bool presence(liste l, short chiffre);

#endif

