#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "types.h"
#include "fonctions_coeur.h"


void generation(short** grille, short taille){
	short i, j;
	place p;
	short chiffre, a;
	bool present_lc, recommencer;


	do{
		recommencer=false;

		remplir_zero(grille, taille);

		for(chiffre=1; chiffre<=taille && !recommencer; chiffre++){
			/* parcours des regions */
			for(i=0; i<taille && !recommencer; i=i+sqrt(taille)){
				for(j=0; j<taille && !recommencer; j=j+sqrt(taille)){
					/* On attribut au chiffre une place au hasard grace a ses coordonnees */
					p.x = rand()%(short)(sqrt(taille))+j;
					p.y = rand()%(short)(sqrt(taille))+i;
					
					/* On verifie si le chiffre se trouve deja dans la ligne ou la colonne */
					present_lc = verif_lc(grille, p, chiffre);
					a=0;

					/* Tant que la case attribue contient deja un chiffre ou que le chiffre se trouve deja dans la ligne ou la colonne,
					on passe  la case suivante de la region,
					on verifie si le chiffre est deja present dans la ligne ou la colonne */
					while((grille[p.y][p.x]!=0 || present_lc) && !recommencer){
						case_suivante(&p, sqrt(taille));
						
						present_lc = verif_lc(grille, p, chiffre);
						a++;
						/* Si toutes les possibilits de cases sont puises et qu'on n'a pas plac le chiffre,
						on va recommencer  zero */
						if(a>taille)
							recommencer=true;
					}

					/* Si on peut placer le chiffre dans la case alors on le place */
					if(!recommencer)
						grille[p.y][p.x]=chiffre;
				}
			}
		}
	}
	while(recommencer);
}
