#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "types.h"
#include "fonctions_coeur.h"


bool valider(short** grille, short taille){
	short table[taille]; 
	short i, j, k, l;
	bool valide=true;

	/*verification des lignes*/
	for(j=0; j<taille && valide; j++){
		for(i=0; i<taille; i++){
			table[i]=0;
		}
		
		for(i=0; i<taille; i++){
			table[grille[j][i]-1]++;
		}
		
		for(i=0; i<taille; i++){
			if(table[i]==0)
				valide=false;
		}
	}

	/*verification des colonnes*/
	for(j=0; j<taille && valide; j++){
		for(i=0; i<taille; i++){
			table[i]=0;
		}
		
		for(i=0; i<taille; i++){
			table[grille[i][j]-1]++;
		}
		
		for(i=0; i<taille; i++){
			if(table[i]==0)
				valide=false;
		}
	}

	/*verification des regions*/
	for(i=0; i<taille; i=i+sqrt(taille)){
		for(j=0; j<taille; j=j+sqrt(taille)){
			for(k=0; k<taille; k++){
				table[k]=0;
			}
		
			for(k=i; k<i+sqrt(taille); k++){
				for(l=j; l<j+sqrt(taille); l++){
					table[grille[k][l]-1]++;
				}
			}
		
			for(k=0; k<taille; k++){
				if(table[k]==0){
					valide=false;
				}
			}
		}
	}
	return valide;
}
